﻿using System;
using System.Drawing;
using MonoTouch.Foundation;
using MonoTouch.UIKit;
using Infragistics;
using System.Collections.Generic;

namespace UsingCustomLabel_Xamarin
{
	public class MyDataClass : NSObject
	{
		[Export("firstName")]
		public string FirstName { get; set; }

		[Export("lastName")]
		public string LastName { get; set; }

		[Export("salary")]
		public double Salary {get;set;}

		[Export("region")]
		public string Region { get; set; }
	}

	public partial class UsingCustomLabel_XamarinViewController : UIViewController
	{
		IGChartView _chart;
		MyCustomChartDelegate _delegate;
		IGCategorySeriesDataSourceHelper _helper;
		NSObject[] _data;

		NSObject[] MakeData()
		{ 
			List<MyDataClass> data = new 
				List<MyDataClass> ();

			MyDataClass d1 = new MyDataClass ();
			d1.FirstName = @"Bob";
			d1.LastName = @"Smith";
			d1.Salary = 25000.0;
			d1.Region = @"Region 1";

			data.Add (d1);

			d1 = new MyDataClass ();
			d1.FirstName = @"Joe";
			d1.LastName = @"Jones";
			d1.Salary = 45000.0;
			d1.Region = @"Region 2";

			data.Add (d1);

			d1 = new MyDataClass ();
			d1.FirstName = @"Sam";
			d1.LastName = @"Doe";
			d1.Salary = 35000.0;
			d1.Region = @"Region 1";

			data.Add (d1);

			return data.ToArray();
		}


		static bool UserInterfaceIdiomIsPhone {
			get { return UIDevice.CurrentDevice.UserInterfaceIdiom == UIUserInterfaceIdiom.Phone; }
		}

		public UsingCustomLabel_XamarinViewController ()
			: base (UserInterfaceIdiomIsPhone ? "UsingCustomLabel_XamarinViewController_iPhone" : "UsingCustomLabel_XamarinViewController_iPad", null)
		{
		}

		public override void DidReceiveMemoryWarning ()
		{
			// Releases the view if it doesn't have a superview.
			base.DidReceiveMemoryWarning ();
			
			// Release any cached data, images, etc that aren't in use.
		}

		public override void ViewDidLoad ()
		{
			base.ViewDidLoad ();
			
			// Perform any additional setup after loading the view, typically from a nib.

			_delegate = new MyCustomChartDelegate ();
			_chart = new IGChartView ();
			_chart.Frame = new RectangleF (0, 0, this.View.Bounds.Size.Width, this.View.Bounds.Size.Height);
			_chart.AutoresizingMask = UIViewAutoresizing.FlexibleHeight | UIViewAutoresizing.FlexibleWidth;

			this.View.AddSubview (_chart);
			_chart.Delegate = _delegate;
		
			_data=this.MakeData();
			_helper = new IGCategorySeriesDataSourceHelper (_data , "salary");
			_helper.LabelPath = "region";

			IGColumnSeries columnSeries =(IGColumnSeries) _chart.AddSeries ( new MonoTouch.ObjCRuntime.Class ("IGColumnSeries"),
				"a", _helper, "x", "y");

			columnSeries.YAxis.Minimum = 15000;
			columnSeries.YAxis.Maximum = 50000;
			_chart.Theme = IGChartDefaultThemes.IGTheme();


		}
	}
}

